田草博客

互联网田草博客


网友交流QQ群:11740834 需注明申请加入原因

微信 公众号:ByCAD

邮箱:tiancao1001x126.com
ByCAD,微信公众号
首页 | 普通 | 电脑 | AutoCAD | VB/VB.NET | FLash | 结构 | 建筑 | 电影 | BIM | 规范 | 软件 | ID
-随机-|-分布-
-博客论坛-|-﨣﨤﨧﨨-
-网站导航-|-规范下载-
-BelovedFLash欣赏-

用户登陆
用户:
密码:
 

站点日历
73 2024 - 4 48
 123456
78910111213
14151617181920
21222324252627
282930


站点统计

最新评论



.Editor.WriteMessage Bounding Boxes around Blocks.
未知 Extents3d.AddExtents   [ 日期:2018-01-15 ]   [ 来自:本站原创 ]  HTML
https://forums.autodesk.com/t5/net/bou ... und-blocks/td-p/3822317
<CommandMethod("GetBound")> _
    Public Shared Sub RunGetBound()
        Dim dwg As Document = Application.DocumentManager.MdiActiveDocument
        Dim ed As Editor = dwg.Editor

        Dim entIds As ObjectId() = SelectEntities(ed)
        If entIds IsNot Nothing Then
            DrawBoundBox(dwg, entIds)
        End If

        Autodesk.AutoCAD.Internal.Utils.PostCommandPrompt()
    End Sub


    Private Shared Function SelectEntities(ByVal ed As Editor) As ObjectId()
        Dim opt As New PromptSelectionOptions()
        opt.MessageForAdding = "Select:"
        Dim res As PromptSelectionResult = ed.GetSelection(opt)
        If res.Status = PromptStatus.OK Then
            Return res.Value.GetObjectIds()
        Else
            Return Nothing
        End If
    End Function


    Private Shared Sub DrawBoundBox(ByVal dwg As Document, ByVal entIds As ObjectId())
        Using tran As Transaction = dwg.TransactionManager.StartTransaction()
            Dim ext As Extents3d = GetBoundBox(entIds, tran)
            Dim poly As Polyline = DrawPolygon(ext)

            Dim space As BlockTableRecord = TryCast(tran.GetObject(dwg.Database.CurrentSpaceId, OpenMode.ForWrite), BlockTableRecord)

            space.AppendEntity(poly)
            tran.AddNewlyCreatedDBObject(poly, True)

            tran.Commit()
        End Using
    End Sub


    Private Shared Function GetBoundBox(ByVal entIds As ObjectId(), ByVal tran As Transaction) As Extents3d
        Dim ex As New Extents3d()

        For Each id As Object In entIds
            Dim ent As Entity = TryCast(tran.GetObject(id, OpenMode.ForRead), Entity)
            ex.AddExtents(ent.GeometricExtents)
        Next

        Return ex
    End Function

    Private Shared Function DrawPolygon(ByVal ext As Extents3d) As Polyline
        Dim pl As New Polyline(4)

        pl.AddVertexAt(0, New Point2d(ext.MinPoint.X, ext.MinPoint.Y), 0.0, 0.0, 0.0)
        pl.AddVertexAt(1, New Point2d(ext.MinPoint.X, ext.MaxPoint.Y), 0.0, 0.0, 0.0)
        pl.AddVertexAt(2, New Point2d(ext.MaxPoint.X, ext.MaxPoint.Y), 0.0, 0.0, 0.0)
        pl.AddVertexAt(3, New Point2d(ext.MaxPoint.X, ext.MinPoint.Y), 0.0, 0.0, 0.0)
        pl.Closed = True
        pl.SetDatabaseDefaults()

        Return pl
    End Function


[本日志由 tiancao1001 于 2018-01-16 00:03 AM 编辑]


暂时没有评论
发表评论 - 不要忘了输入验证码哦!
作者: 用户:  密码:   注册? 验证:  防止恶意留言请输入问题答案:1*7=?  
评论:

禁止表情
禁止UBB
禁止图片
识别链接
识别关键字

字体样式 文字大小 文字颜色
插入粗体文本 插入斜体文本 插入下划线
左对齐 居中对齐 右对齐
插入超级链接 插入邮件地址 插入图像
插入 Flash 插入代码 插入引用
插入列表 插入音频文件 插入视频文件
插入缩进符合
点击下载按钮 下标 上标
水平线 简介分割标记
表  情
 
Tiancao Blog All Rights Reserved 田草博客 版权所有
Copyright ©